package lejos;

import java.lang.reflect.InvocationTargetException;
import java.net.*;
import java.io.*;

import org.eclipse.ui.*;
import org.eclipse.ui.actions.WorkspaceModifyDelegatingOperation;
import org.eclipse.ui.dialogs.WizardNewProjectCreationPage;
import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard;
import org.eclipse.jface.operation.IRunnableWithProgress;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.core.boot.*;
import org.eclipse.core.runtime.*;
import org.eclipse.jdt.core.*;
import org.eclipse.jdt.internal.ui.*;
import org.eclipse.jdt.internal.ui.util.ExceptionHandler;
import org.eclipse.jdt.internal.ui.wizards.*;
import org.eclipse.jdt.ui.wizards.JavaCapabilityConfigurationPage;

/**
 * This is rather a hack for eclipse 2.0 (using internal class)
 * @see Wizard
 */
public class LejosWizard extends NewProjectCreationWizard {
// this code makes use of eclipse 2.0 internals

	
	/*
	 * @see Wizard#performFinish
	 */		
	public boolean performFinish() {
		boolean res=super.performFinish();
		
		// updating classspath
		customize();
		
		return res;
	}
		    
	// customize the classpath for compiling !
    private void customize() {

        try {
  			JavaCapabilityConfigurationPage page=(JavaCapabilityConfigurationPage)getPage("JavaCapabilityConfigurationPage");
			if (page!=null) {
				IJavaProject prj=page.getJavaProject();				
				IClasspathEntry[] ocp=prj.getRawClasspath();
				IClasspathEntry[] ncp=new IClasspathEntry[ocp.length+3];
				for(int i=0; i<ocp.length; i++) ncp[i]=ocp[i];
				if (ocp.length>0) ncp[ncp.length-1]=ocp[ocp.length-1];

				// JVM libs
				String home=LejosPlugin.getDefault().getLejosPath();
				File fp=new File(home,"lib/classes.jar");
				Path cp=new Path(fp.getCanonicalPath());
				IClasspathEntry icp=JavaCore.newLibraryEntry(cp,null,null);
				ncp[ncp.length-4]=icp;

				fp=new File(home,"lib/rcxrcxcomm.jar");
				cp=new Path(LejosPlugin.getPath(fp));
				icp=JavaCore.newLibraryEntry(cp,null,null);
				ncp[ncp.length-3]=icp;

				fp=new File(home,"lib/pcrcxcomm.jar");
				cp=new Path(LejosPlugin.getPath(fp));
				icp=JavaCore.newLibraryEntry(cp,null,null);
				ncp[ncp.length-2]=icp;				

				prj.setRawClasspath(ncp,null);
			}	
        } catch(Exception e) {
        }
		
/*		
		// TODO conditionally enable RCX menu in the main toolbar (maybe as extension point)
		URL[] pp=BootLoader.getPluginPath(LejosPlugin.plugin.getDescriptor().getInstallURL());
		for(int i=0; i<pp.length; i++) System.out.println(pp[i]);
		
		System.out.println("IURL: "+BootLoader.getInstallURL()+LejosPlugin.plugin.getDescriptor().getInstallURL());
*/		
	}

}
